"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const prop_types_1 = require("prop-types");
const utils_1 = require("./utils");
const Context_1 = __importDefault(require("./Context"));
const createSelectable = (WrappedComponent) => { var _a; return _a = class SelectableItem extends react_1.Component {
        constructor() {
            super(...arguments);
            this.state = {
                isSelected: this.props.isSelected,
                isSelecting: false
            };
            this.node = null;
            this.bounds = null;
            this.registerSelectable = (containerScroll) => {
                this.bounds = utils_1.getBoundsForNode(this.node, containerScroll);
                this.context.selectable.register(this);
            };
            this.getSelectableRef = (ref) => {
                this.node = ref;
            };
        }
        componentDidMount() {
            this.registerSelectable();
        }
        componentWillUnmount() {
            this.context.selectable.unregister(this);
        }
        render() {
            return (react_1.default.createElement(WrappedComponent, Object.assign({}, this.props, this.state, { selectableRef: this.getSelectableRef })));
        }
    },
    _a.contextType = Context_1.default,
    _a.propTypes = {
        isSelected: prop_types_1.bool
    },
    _a.defaultProps = {
        isSelected: false
    },
    _a; };
exports.default = createSelectable;
//# sourceMappingURL=CreateSelectable.js.map