"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const getBoundsForNode_1 = require("./getBoundsForNode");
const areBoundsCollide = (a, b, { tolerance = 0, useOffsetSize = false }) => {
    const aHeight = useOffsetSize ? a.offsetHeight : a.height;
    const bHeight = useOffsetSize ? b.offsetHeight : b.height;
    const aWidth = useOffsetSize ? a.offsetWidth : a.width;
    const bWidth = useOffsetSize ? b.offsetWidth : b.width;
    return !(a.top + aHeight - tolerance < b.top ||
        a.top + tolerance > b.top + bHeight ||
        a.left + aWidth - tolerance < b.left ||
        a.left + tolerance > b.left + bWidth);
};
function doObjectsCollide(a, b, tolerance = 0, delta = 1) {
    const aObj = a instanceof HTMLElement ? getBoundsForNode_1.getBoundsForNode(a) : a;
    const bObj = b instanceof HTMLElement ? getBoundsForNode_1.getBoundsForNode(b) : b;
    return areBoundsCollide(aObj, bObj, { tolerance, useOffsetSize: delta === 1 });
}
exports.doObjectsCollide = doObjectsCollide;
//# sourceMappingURL=doObjectsCollide.js.map