"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getDocumentScroll() {
    const documentScrollTop = Math.max(window.pageYOffset, document.documentElement.scrollTop, document.body.scrollTop);
    const documentScrollLeft = Math.max(window.pageXOffset, document.documentElement.scrollLeft, document.body.scrollLeft);
    return { documentScrollTop, documentScrollLeft };
}
exports.getDocumentScroll = getDocumentScroll;
function getBoundsForNode(node, containerScroll = { scrollTop: 0, scrollLeft: 0 }) {
    const { scrollTop, scrollLeft } = containerScroll;
    const { documentScrollTop, documentScrollLeft } = getDocumentScroll();
    const rect = node.getBoundingClientRect();
    return {
        top: rect.top + documentScrollTop + scrollTop,
        left: rect.left + documentScrollLeft + scrollLeft,
        offsetWidth: node.offsetWidth,
        offsetHeight: node.offsetHeight,
        width: rect.width,
        height: rect.height
    };
}
exports.getBoundsForNode = getBoundsForNode;
//# sourceMappingURL=getBoundsForNode.js.map